unit NummerControle;
  { (c) 2009, Tom Verhoeff (SET @ TU/e ) }
  { Routines ter controle van bankrekeningnummers }

// Please do not remove the BEGIN-END TODO markers

//# BEGIN TODO Aangevuld door: naam, id.nr., datum
  Replace this line by your text.
//# END TODO

interface

function DeCijfers ( const AString: String ): String;
  { pre: True
    ret: AString waaruit alle niet-cijfers verwijderd zijn }

function BevatAlleenCijfers ( const AString: String ): Boolean;
  { pre: True
    ret: of AString uit alleen cijfers bestaat }

function IsGeldigNummer ( const ANummer: String ): Boolean;
  { pre: n = Length(ANummer) <= 10 en
         BevatAlleenCijfers(ANummer) en
         ANummer = c_n ... c_3 c_2 c_1
    ret: (+ w: 1 <= w <= n: w * c_w) mod 11 = 0 }

implementation

uses
  SysUtils; // voor StrToInt

const
  Cijfers = [ '0' .. '9' ]; // de cijfers

function DeCijfers ( const AString: String ): String;
var
  i: Integer; // doorloopt AString
begin
  Result := '';

  for i := 1 to Length(AString) do begin
    if AString[i] in Cijfers then begin
      Result := Result + AString[i];
    end;
  end; { for i }

end;

function BevatAlleenCijfers ( const AString: String ): Boolean;
begin
  Result := AString = DeCijfers ( AString );
end;

function IsGeldigNummer ( const ANummer: String ): Boolean;
var
  i: Integer; // doorloopt ANummer
  s: Integer; // gewogen cijfersom
  w: Integer; // weegfactor
begin
//# BEGIN TODO body van IsGeldigNummer
  Replace this line by your text.
//# END TODO
end;

end.
